/////////////////////////////////////////////////////////////////////////////
// HexEditCtrlDoc.cpp : implementation of the CHexEditCtrlDoc class
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// includes
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "HexEditCtrl.h"
#include "HexEditCtrlDoc.h"


/////////////////////////////////////////////////////////////////////////////
// defines
/////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DOC_EMPTY_STR	"this is an empty document... open a  file!"

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// class CHexEditCtrlDoc
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNCREATE(CHexEditCtrlDoc, CDocument)

BEGIN_MESSAGE_MAP(CHexEditCtrlDoc, CDocument)
	//{{AFX_MSG_MAP(CHexEditCtrlDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



CHexEditCtrlDoc::CHexEditCtrlDoc() : m_pData(NULL), m_nSize(0)
{ 
}

CHexEditCtrlDoc::~CHexEditCtrlDoc()
{
	delete []m_pData;
}

BOOL CHexEditCtrlDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	
	delete []m_pData;
	m_nSize = strlen(DOC_EMPTY_STR)+1;
	m_pData = new BYTE[m_nSize];
	strcpy((char*)m_pData, DOC_EMPTY_STR);
	return TRUE;
}

void CHexEditCtrlDoc::Serialize(CArchive& ar)
{
	CFile *pFile = ar.GetFile();
	ASSERT(pFile != NULL);

	if (ar.IsStoring()) {
		pFile->WriteHuge(m_pData, m_nSize);
	} else {
		delete []m_pData;
		m_nSize = ar.GetFile()->GetLength();
		ASSERT(m_nSize < 0x7ffff0000);
		m_pData = new BYTE[m_nSize];
		ASSERT(m_pData != NULL);
		pFile->ReadHuge(m_pData, m_nSize);
	}
}

#ifdef _DEBUG
void CHexEditCtrlDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CHexEditCtrlDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
